// Funkcje do liczenia meteorkow

// kolekcja stalych liczb

#define pi 3.1415926535898              // PI
#define pi2 1.5707963268                // PI/2
#define d2r 3.1415926535898/180.0       // zamiana katow na radiany
#define r2d 180/3.1415926535898         // i w druga strone
#define e 23.439                        // nachylenie ekliptyki do rownika

void nextday(int date[])
{
FILE*we;

int td,tm,ty,tp;
double ts;
int i=0;
int t=0;

we=fopen("sol.dat","r");
while((fscanf(we,"%d %d %d %d %lf",&td,&tm,&ty,&tp,&ts))!=EOF)
        {
        if(i==1) {date[0]=ty; date[1]=tm; date[2]=td;  break;}
        if(ty==date[0] && tm==date[1] && td==date[2] && tp==22) {i=1;}
        t++;
        if(t%10000==0) fflush(we);      
        }
fclose(we);

// printf("af %d %d %d\n",date[0],date[1],date[2]);

}

double sol_long(int year, int mnt, int day, double h, double m, double s)
{
FILE*we;

double beg,end;
double frac,sol;
int ibeg;
int td,tm,ty,tp;
double ts;
int i;

i=0;

h=h+m/60+s/3600;

beg=(int)(h/2)*2;       // Przedzial 2-godzinny poczatkowy
ibeg=(int)(beg);
end=(int)(h/2)*2+2;     // Przedzial 2-godzinny koncowy

frac=(h-(int)(h/2)*2)/2; // Czesc przedzialu 2-godzinnego jaka uplynela

/* Wczytuje plik z dlugoscia ekliptyczna Slonca */

we=fopen("sol.dat","r");

while((fscanf(we,"%d %d %d %d %lf",&td,&tm,&ty,&tp,&ts))!=EOF)
        {
        if(i==1) {end=ts; break;}       
        if(ty==year && td==day && tm==mnt && tp==ibeg) {beg=ts; i=1;}
        }
fclose(we);

if(end<beg) end+=360; // Przeskok przez rownonoc wiosenna.

sol=(end-beg)*frac+beg;

if(sol>360) sol-=360; // Przeskok przez rownonoc wiosenna.

return sol;
}

double sol(int yearb, int mntb, int dayb, double hourb, double minb, double secb, double houre, double mine, double sece)
{

int year, mnt, day, date[3];
double hour, min, sec;
double sol;

        hourb=hourb+minb/60+secb/60/60;
        houre=houre+mine/60+sece/60/60;

// no change of day

        if(hourb>=12 && hourb<24 && houre>=12 && houre<24)
        {
        hour=(houre+hourb)/2;
        }

        if(houre<12 && hourb<12)
        {
        hour=(houre+hourb)/2;
        }

        if(hourb>houre && houre<12 && 24-hourb>houre)
        {
        hour=(houre+24+hourb)/2;
        }       

        if(houre<12 && hourb<12)
        {
        date[0]=yearb;
        date[1]=mntb;
        date[2]=dayb;
        nextday(date);
        yearb=date[0];
        mntb=date[1];
        dayb=date[2];
        hour=(houre+hourb)/2;
        }


// change of day !

        if(hourb>houre && houre<12 && 24-hourb<=houre)
        {
        // troubles becouse we have a change of date so we have to 
        // check what is a next date: day, mnt && year in sol.dat

        date[0]=yearb;
        date[1]=mntb;
        date[2]=dayb;
        nextday(date);
        yearb=date[0];
        mntb=date[1];
        dayb=date[2];
        
//      printf("%d %d %d\n",yearb,mntb,dayb);

        houre=houre+24;
        hour=(houre+hourb)/2-24;

//      printf("%07.3lf\n",sol_long(yearb,mntb,dayb,hour,0,0,0);
        }

//      printf("%d %d %d\n",yearb,mntb,dayb);
        sol=sol_long(yearb,mntb,dayb,hour,0,0);
	
	return sol;

}

/* check if it is not a next day */

void check_date(int yearb, int mntb, int dayb, double hourb, double minb, double secb, double houre, double mine, double sece, int date[])
{

int year, mnt, day;
double hour, min, sec;
double sol;

	//printf("%d %d %d\n",date[0],date[1],date[2]);	
         
        hourb=hourb+minb/60+secb/60/60;
        houre=houre+mine/60+sece/60/60;
         
// no change of day   

        if(hourb>=12 && hourb<24 && houre>=12 && houre<24)
        {
        hour=(houre+hourb)/2;
        }
        
        if(houre<12 && hourb<12)
        {
        hour=(houre+hourb)/2;
        }

        if(hourb>houre && houre<12 && 24-hourb>houre)
        {
        hour=(houre+24+hourb)/2;
        }

        if(houre<12 && hourb<12)
        {
        date[0]=yearb;
        date[1]=mntb;
        date[2]=dayb;
        nextday(date);
        yearb=date[0];
        mntb=date[1];
        dayb=date[2];
 
        hour=(houre+hourb)/2;
        }

// change of day !

        if(hourb>houre && houre<12 && 24-hourb<=houre)
        {
        // troubles becouse we have a change of date so we have to
        // check what is a next date: day, mnt && year in sol.dat

        date[0]=yearb;
        date[1]=mntb;
        date[2]=dayb;
        nextday(date);

        yearb=date[0];
        mntb=date[1];
        dayb=date[2];
 
//      printf("%d %d %d\n",yearb,mntb,dayb);

        houre=houre+24;
        hour=(houre+hourb)/2-24;
         
//      printf("%07.3lf\n",sol_long(yearb,mntb,dayb,hour,0,0,0);
        }
//	printf("%d %d %d\n",date[0],date[1],date[2]);

}


/* Zamiana wspolrzednych (ra,dec) -> (lambda,beta) */
             
double ekl(double ra, double dec, int co)
        {

        double lambda,beta;
        lambda=beta=0;

        if ( ra > 0 && ra <= 90 )
          {
             beta=cos(e*d2r)*cos(pi2-dec*d2r)+sin(e*d2r)*sin(pi2-dec*d2r)*cos(pi2+ra*d2r);
             beta=pi2-acos(beta);
             lambda=(cos(pi2-dec*d2r)-cos(pi2-beta)*cos(e*d2r))/(sin(pi2-beta)*sin(e*d2r));
             if(lambda>1)lambda=1;
             if(lambda<-1)lambda=-1;
             lambda=pi2-acos(lambda);
          }
        
   
        else if( ra >90 && ra <= 270 )
          {
             beta=cos(e*d2r)*cos(pi2-dec*d2r)+sin(e*d2r)*sin(pi2-dec*d2r)*cos(3*pi2-ra*d2r);
             beta=pi2-acos(beta);
             lambda=(cos(pi2-dec*d2r)-cos(pi2-beta)*cos(e*d2r))/(sin(pi2-beta)*sin(e*d2r));
             if(lambda>1)lambda=1;
             if(lambda<-1)lambda=-1;
             lambda=pi2+acos(lambda);
          }
        
        
        else if(ra>270 && ra <= 360)
          {
             beta=cos(e*d2r)*cos(pi2-dec*d2r)+sin(e*d2r)*sin(pi2-dec*d2r)*cos(-3*pi2+ra*d2r);
             beta=pi2-acos(beta);
             lambda=(cos(pi2-dec*d2r)-cos(pi2-beta)*cos(e*d2r))/(sin(pi2-beta)*sin(e*d2r));
             if(lambda>1)lambda=1;
             if(lambda<-1)lambda=-1;
             lambda=fabs(-5*pi2+acos(lambda));
          }

        if(co==0) return fabs(r2d*lambda);
        if(co==1) return r2d*beta;

}


/* Zamiana wspolrzednych (ra,dec) -> (lambda,beta) */
        
double row(double lam, double bet, int co)
{        
        double ra,dec;
        ra=dec=0;       

        if(lam>360) lam=lam-360;
        if(lam<0) lam=360+lam;

        if ( lam>0 && lam<=90 )
          {
             dec=cos(e*d2r)*cos(pi2-bet*d2r)+sin(e*d2r)*sin(pi2-bet*d2r)*cos(pi2-lam*d2r);   
             dec=pi2-acos(dec);
             ra=(cos(pi2-bet*d2r)-cos(pi2-dec)*cos(e*d2r))/(sin(pi2-dec)*sin(e*d2r));
             if(ra>1)ra=1;
             if(ra<-1)ra=-1;
             ra=pi2-acos(ra);
          }

        else if( lam>90 && lam<=270 )
          {
             dec=cos(e*d2r)*cos(pi2-bet*d2r)+sin(e*d2r)*sin(pi2-bet*d2r)*cos(-pi2+lam*d2r);
             if(dec>=1)dec=1;  
             if(dec<=-1)dec=-1;
             dec=pi2-acos(dec);
             ra=(cos(pi2-bet*d2r)-cos(pi2-dec)*cos(e*d2r))/(sin(pi2-dec)*sin(e*d2r));
             if(ra>=1)ra=1;
             if(ra<-1)ra=-1;
             ra=3*pi2-acos(ra);
          }

        else if( lam>=270 && lam<=360 )
          {
             dec=cos(e*d2r)*cos(pi2-bet*d2r)+sin(e*d2r)*sin(pi2-bet*d2r)*cos(5*pi2-lam*d2r);
             if(dec>=1)dec=1;   
             if(dec<=-1)dec=-1; 
             dec=pi2-acos(dec);
             ra=(cos(pi2-bet*d2r)-cos(pi2-dec)*cos(e*d2r))/(sin(pi2-dec)*sin(e*d2r));
             if(ra>=1)ra=1;   
             if(ra<-1)ra=-1;   
             ra=3*pi2+acos(ra); 
          }

        if(co==0) return fabs(r2d*ra);
        if(co==1) return r2d*dec; 
}


/*
Data Julianska i dlugosc eklpityczna Slonca dla dowolnego momentu

        0       JD
        1       lambda_sol
*/

double jd(double year, double mnt, double day, double hour, double min, int co)
{

        double juldate;
        double a, b, dayfrac;
        int tmp;        
        double t,lo,m,c,s; // zmienne jd2sollon

        if(co==0 || co==1)

        day=day+hour/24+min/(24*60);    
//      day=day+mgodz/23.93;

        
        dayfrac=day-floor(day); // czesc dnia
        day=floor(day);         // dzien

        a=0;
        b=0;

        if (mnt < 3)
           {
         if (mnt==1)
        {
         mnt = 13;
         }
         else
        {
         mnt = 14;
        }
        year  = year - 1;
        }

        if ((year>1582) || ((year==1582) && (mnt>10)) || ((year==1582) && (mnt==10) && (day>=15)))

        {
           a = floor(year/100);
           b = 2 - a + floor(a/4);
        }

        juldate = floor(365.25*year + 365.25*4716.0) + floor(30.6001*mnt+ 30.6001) + day + b - 1524.5 + dayfrac;

        if(co==0) { return juldate; }   

        if(co==1)       
        {

// Let JD be the Julian (Ephemeris) Day. Then the time T, measured in
// Julian Centuries of 36525 ephemeris days from the epoch J2000.0 (2000
// January 1.5 TD), which is given by:

        t = (juldate - 2451545.0) / 36525.;

// This quantity should be calculated with a sufficient number of decimals.
// One minute in time corresponds with a difference of 0.000000019 in t.

// Then the geometric mean longitude of the Sun, reffered to the mean
// equinox of the date, is given by:



        lo = 280.46645 + 36000.76983*t + 0.0003032*pow(t,2);
        
        tmp=floor(lo/360.);

        lo = lo-tmp*360;

//    The mean anomaly of the Sun is:

        m = 357.52910 + 35999.05030*t - 0.0001559*pow(t,2) - 0.00000048*pow(t,3);

        tmp=floor(m/360.);

        m = m-tmp*360;

//    Then find the Sun's equation of center C as follows:

        c = (1.914600 - 0.004817*t - 0.000014*t*t)*sin(m*d2r) + (0.01993-0.000101*t)*sin((2*m)*d2r) + 0.000290*sin((3*m)*d2r);

//    Then the Sun's true longitude is:

        s=lo+c;

        return s;

        }
        
}


/*
        
Ilosc dni od J2000.0
 
*/


double numday(double y, double m, double d, double h, double min)
{

/* returns the days since J2000.0 number assuming the Gregorian calendar 
   after 1582 Oct 4th given the year, month, day, hour and minute
   This method is modified from Duffett-Smith Calculator page 7
   Negative years CE are numbered according to the astronomical
   convention - i.e. calendrical year 1 BC is year zero in this function
*/
        double greg,a,b,c,d1;

        greg = y*10000 + m*100 + d;

        if(m == 1 || m == 2)
        {
                y = y - 1;
                m = m + 12;
        }

        if(greg > 15821004)
        {
                a = floor(y/100);
                b = 2 - a  + floor(a/4);
        }
        else b = 0;

        c = floor(365.25 * y);
        d1 = floor(30.6001 * (m + 1));
        return b + c + d1 -730550.5 + d + (h+min/60)/24;

}

/* Czas gwiazdowy GMST dla dowolnej daty - z tego co przetestowalem z dokladnoscia do ok 90 sek. */

double sid(double year, double mnt, double day, double hour, double min)
{

/*  returns the greenwich siderial time corresponding to the number of days
    before J2000.0 (Meeus Ch 11). 
    Answer is given in degrees (360 = siderial day)
*/

        double t;
        double st;

        day=numday(year,mnt,day,hour,min);

        t = day/36525;
        st = fmod(280.46061837 + 360.98564736629 * day + 0.000387933 * t* t - t*t*t/38710000, 360);
        if(st < 0) st = st + 360;

        return st;
}

// wysokosc punktu o wspolrzednych ra, dec dla danej daty: year, mnt, day, hour, min i miejsca: lat, lon

double alt(double year, double mnt, double day, double hour, double min, double ra, double dec, double lat, double lon)
        {
        
        double ha;
        double st;
        double wys;

        st=sid(year,mnt,day,hour,min);

        ha=st-ra+lon;
        
        if(ha<0) ha=ha+360;
        if(ha>360) ha=ha-360;

        ha=ha*d2r;      
        dec=dec*d2r;
        lat=lat*d2r;

        wys=sin(dec)*sin(lat)+cos(dec)*cos(lat)*cos(ha);
        wys=asin(wys)*r2d;
        
        return wys;
        }


/* Trojkat wierzcholkowy: a,b,c,dy. UWAGA: 'a' zwracane w radianach
Szukamy kata 'a' gdzie x1,y1 i x2,y2 wierzcholki na ktorych rozpiety kat 'a'.
*/

double tricos(double x1, double y1, double x2, double y2)
{       
        double dx;
        double a;

        x1=x1*d2r;
        x2=x2*d2r;
        y1=y1*d2r;
        y2=y2*d2r;      
        dx=x2-x1;

        a=acos( sin(y1)*sin(y2)+cos(y1)*cos(y2)*cos(dx) ); // wzor kosinusow
        return a;
}

/*      
Liczymy rozmiar radiantu (zalezne od jego odleglosci od konca meteoru)

Dla zwyklego roju tj. nie nadaje sie do "starych" rojow ekliptycznych
tj. Virginid, Sagittaryd, d-Cancryd lub N i S Tauryd;

Zwraca promien (r, NIE SREDNICE = 2 r) liczony w stopniach.

        0       skala podawana przez IMO i w poradniku do szkicowania
        1       skala liniowa na podstawie 0
*/

double radii(double lamr, double betr, double lamb, double betb, double lame, double bete, double rbeg, int co)
{
        double dise,r;
        
        dise=tricos(lamr,betr,lame,bete)*r2d;
        if(co==0)
                {
                r=rbeg;
                if(dise>=15) r=14;
                if(dise>=30) r=17; 
                if(dise>=50) r=20;
                if(dise>=70) r=23;
                }
        if(co==1 && dise>=15) r=0.18571429*dise+10;     // dla duzych odleglosci uliniawia przypadek 'co=0'
        if(co==1 && dise<15)  r=dise*(14-rbeg)/15+rbeg; // dla malych odleglosci uwzglednia 'rbeg' rozmiar radiantu podawany w tablicach
        return r/2;
}

/* Nowy warunek drugi - trafienie w radiant

rozaptrujemy dwa trojkaty:

1. o wierzcholkach w radiancie R, koncu meteoru E i punkcie S w ktorym
kolo wielkie przechodzace przez E jest styczne do radiantu -> kat RSE jest katem prostym !!!

kat 'alpha' to kat SER 

2. o wierzcholkach w radiancie R, poczatku meteoru B i koncu meteoru E

kat 'beta' to kat BER

stad warunek wystarczajacy trafiania to 'beta'<='alpha'

prawie wszystko da sie policzyc... oznaczenia w funkcji sa analogiczne
za zmienna kat RS uzywam polowe srednicy

*/

double war2b(double lamr, double betr, double lamb, double betb,  double lame, double bete, double r)
        {

        double re,rb,be,se,alpha=0,beta=0;      

        r=r*d2r;
        
        re=tricos(lamr,betr,lame,bete);
        rb=tricos(lamr,betr,lamb,betb);
        be=tricos(lamb,betb,lame,bete);

        beta=acos( (cos(rb)-cos(re)*cos(be)) / (sin(re)*sin(be)) );     // wzor kosinusow dla 1. trojkata

/*      se=acos( cos(re)/cos(r) ); alpha1=acos( (cos(r)-cos(re)*cos(se))/sin(re)*sin(se) ); */

        alpha=asin( sin(r)/sin(re) );   // wzor sinsow: sin(re)/sin(90)=sin(rs)/sin(alpha) dla 2. trojkata

// 	printf("re: %lf\t",re*r2d);
//	printf("rb: %lf\t",rb*r2d);
//	printf("be: %lf\t",be*r2d);

        alpha=fabs(alpha*r2d);
        beta=fabs(beta*r2d);

//        printf("alpha: %lf\t",alpha);
//        printf("beta: %lf\t",beta);
        
        if(beta<=alpha) { return 1;}
//      if(beta<=alpha || (90-beta)<=alpha) { return 1;}
        else { return 0;}
//      if(beta>alpha) return 0;        

        }

/* Liczy dryf radiantu dla podanych wspolrzednych liczac iloscia dni 'odmax' od dnia maximum  */

double dryf(double rar, double decr, double odmax)
        {

        double lamr,betr;

        lamr=ekl(rar,decr,0);
        betr=ekl(rar,decr,1);            

//      printf("betr: %lf deg\n",betr);
 
        lamr=lamr+odmax*cos(betr*d2r);

        if(lamr>=360) lamr=lamr-360;
        if(lamr<0) lamr=lamr+360;       

//        printf("lamr: %lf deg\n",lamr);

        return lamr;

        }

/* Blad wyznaczenia predkosci meteoru wzgledem predkosci teoretycznej 'omega'

        -1 - wg. IMO
         0 - wg. skali polowkowej
         1 - wg. skali calkowitej
*/

double dvelrozne(double omega, int co)
        {
        double dvel; dvel=0;
                        
        if(co==-1)
        {
                if(omega<7.5) dvel=3;   
                if(omega>=7.5 && omega<12.5) dvel=5;
                if(omega>=12.5 && omega<17.5) dvel=6;
                if(omega>=17.5 && omega<25) dvel=7;
                if(omega>=25) dvel=8;
        return dvel;
        }

        if(co==0)
        {
                if(omega==0) dvel=0.01;
                if(omega>0.0 && omega<27) dvel=5;
                if(omega>=27) dvel=8;
        return dvel;
        }

        if(co==1)
        {
                if(omega>0.0 && omega<26) dvel=6;
                if(omega>=26) dvel=8;
        return dvel;
        }
        
        }


/* 
Liczymy rozmiar radiantu (promien 1 r) nadaje sie do "starych" rojow ekliptycznych.     
Elipse zastepujemu trzema radiantami kolistymi.
*/
        
double radiiekl(double lamr, double betr, double lamb, double betb, double lame, double bete, double rbegl, double rbegb, int co)
{
        double dise,r;

        dise=tricos(lamr,betr,lame,bete)*r2d;

        if(co==0)
        {
                if(dise<15) r=rbegb;
                if(dise>=15) r=13;
                if(dise>=30) r=18;
                if(dise>=50) r=21;
                if(dise>=70) r=30;
//              printf("r: %lf\n",r);
                return r/2;
        }

        if(co==1)  
        {
                if(dise<15) r=rbegb;
                if(dise>=15) r=20;
                if(dise>=30) r=23;
                if(dise>=50) r=26;
                if(dise>=70) r=34;
//              printf("r: %lf\n",r);
                return r/2;
	}
}
